//+------------------------------------------------------------------+
//|                                                     Ichimoku.mq5 |
//|                                            Copyright 2020, ernst |
//|                             https://www.mql5.com/en/users/pippod |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, ernst"
#property link      "https://www.mql5.com/en/users/pippod"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_plots   4
//--- plot Tenkan
#property indicator_label1  "Tenkan-sen"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrDodgerBlue
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot Kijun
#property indicator_label2  "Kijun-sen"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrFireBrick
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot Senkou
#property indicator_label3  "Senkou Span A;Senkou Span B"
#property indicator_type3   DRAW_FILLING
#property indicator_color3  clrSandyBrown,clrThistle
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1
//--- plot Chikou
#property indicator_label4  "Chikou Span"
#property indicator_type4   DRAW_LINE
#property indicator_color4  clrLimeGreen
#property indicator_style4  STYLE_SOLID
#property indicator_width4  1
//--- input parameters
input int      inpTenkan=9;            //Tenkan-sen
input int      inpKijun=26;            //Kijun-sen
input int      inpSenkou=52;           //Senkou
input int      inpShift=26;            //Cloud shift
//--- indicator buffers
double         TenkanBuffer[];
double         KijunBuffer[];
double         SpanABuffer[];
double         SpanBBuffer[];
double         ChikouBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,TenkanBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,KijunBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,SpanABuffer,INDICATOR_DATA);
   SetIndexBuffer(3,SpanBBuffer,INDICATOR_DATA);
   SetIndexBuffer(4,ChikouBuffer,INDICATOR_DATA);
//--- change labels for DataWindow
   PlotIndexSetString(0,PLOT_LABEL,"Tenkan-sen("+string(inpTenkan)+")");
   PlotIndexSetString(1,PLOT_LABEL,"Kijun-sen("+string(inpKijun)+")");
   PlotIndexSetString(2,PLOT_LABEL,"Senkou Span A;Senkou Span B("+string(inpSenkou)+")");
//---
   PlotIndexSetInteger(2,PLOT_SHIFT, inpShift);
   PlotIndexSetInteger(3,PLOT_SHIFT,-inpShift);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   bool newBar=rates_total!=prev_calculated;
   int begin=(newBar)?prev_calculated:prev_calculated-1;
//--- main loop
   for(int i=begin;i<rates_total && !_StopFlag;i++)
     {
      //--- tenkan sen
      TenkanBuffer[i]=iHighestLowest(newBar,high,low,tkn,inpTenkan,i);
      //--- kijun sen
      KijunBuffer[i]=iHighestLowest(newBar,high,low,kjn,inpKijun,i);
      //--- senkou span a
      SpanABuffer[i]=(TenkanBuffer[i]+KijunBuffer[i])/2.;
      //--- senkou span b
      SpanBBuffer[i]=iHighestLowest(newBar,high,low,snk,inpSenkou,i);
      //--- chikou span
      ChikouBuffer[i]=close[i];
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CHiLo
  {
public:
   double            highst;
   double            lowest;
  }tkn,kjn,snk,*hilo;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double iHighestLowest(const bool new_bar,
                      const double& high[],
                      const double& low[],
                      CHiLo &hi_lo,
                      const int count,
                      const int index)
  {
   if(index-count<=0)
      return(EMPTY_VALUE);
//---
   if(new_bar)
     {
      hi_lo.highst=high[index];
      hi_lo.lowest=low[index]; 
      for(int i=index-count+1;i<index;i++)
        {
         if(hi_lo.highst<high[i])
            hi_lo.highst=high[i];
         if(hi_lo.lowest>low[i])
            hi_lo.lowest=low[i];
        }
     }
//---
   else                           
     {
      if(hi_lo.highst<high[index])
         hi_lo.highst=high[index];
      if(hi_lo.lowest>low[index])
         hi_lo.lowest=low[index];
     }
//---
   return((hi_lo.highst+hi_lo.lowest)/2.);
  }                   
//+------------------------------------------------------------------+
